#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"
#include "Maths.h"

#define SCREEN_WIDTH    640
#define SCREEN_HEIGHT   640

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Lissajous 2", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0, SDL_ALPHA_OPAQUE));


    for (int i = 0; i < 360; i++)
    {
        for (int c2 = 1; c2 < 6; c2++)
            for (int c1 = 1; c1 < 6; c1++)
            {
                int centerX = SCREEN_WIDTH / 2 + (c1 - 3) * 120;
                int centerY = SCREEN_HEIGHT/ 2 + (c2 - 3) * 120;
                int radius = 50;

                float angle0 = DEG_TO_RAD(i);
                int x0 = centerX + radius * cos(c1 * angle0);
                int y0 = centerY + radius * sin(c2 * angle0);

                float angle1 = DEG_TO_RAD(i + 1);
                int x1 = centerX + radius * cos(c1 * angle1);
                int y1 = centerY + radius * sin(c2 * angle1);

                gfx.line(x0, y0, x1, y1, Color(255, 255, 255));
            }

        gfx.render();
        sys.wait(20);
    }

    // wait until we quit
    while (sys.isQuitRequested() == false)
    {
        gfx.render();
        sys.wait(20);
        sys.processEvents();
    }

    gfx.quit();

    return EXIT_SUCCESS;
}
